import os
import re
import subprocess

SHORTLOG_PATTERN = re.compile(r'\s+(?P<lines>\d+)\s+(?P<name>[\w \-]+)\s*')
def shortlog(abspath):
    os.chdir(abspath)
    output = subprocess.check_output(['git', 'shortlog', '-s', '-n'])
    lines = output.split('\n')
    matches = [SHORTLOG_PATTERN.match(line) for line in lines]
    matches = [match for match in matches if match]
    entries = [(match.group('lines'), match.group('name')) for match in matches]
    return entries

